// Gamecube Broadband Adapter Debugger v0.1
// Date: 2003.01.15
// Author: MEGABYTE
// E-mail: megabyte@kontek.net
// Website: http://kontek.net/
// Includes sources by tmbinc and others

#include "../../include/libogc/mygcn.h"
#include "gcif.c"
#include "irq.c"
#include "exi.c"
PAD Pad;

void status(int offset, int width, int height, int active, bool edit, char buffer[])
{
    u32 *fb = (u32*)0xc0500000; 
	RENDER_ClearFrameBuffer(fb, COLOR_BLACK);
	DEBUG_InitText(fb, COLOR_MONEYGREEN);
	DEBUG_Print(0, 10, "Gamecube BBA Debugger v0.1 by MEGABYTE");
	DEBUG_Print(0, 40, "Press A for 100 Mbps, full duplex");
	DEBUG_Print(0, 60, "Press B for 100 Mbps, half duplex");
	DEBUG_Print(0, 80, "Press X for 10 Mbps, full duplex");
	DEBUG_Print(0, 100, "Press Y for 10 Mbps, half duplex");
	DEBUG_Print(0, 120, "Press Start to reload another DOL");
	DEBUG_Print(0, 150, "Broadband Adapter is currently running");
	DEBUG_Print(420, 250, "Press L to");
	DEBUG_Print(420, 270, "Shift up");
	DEBUG_Print(420, 300, "Press R to");
	DEBUG_Print(420, 320, "shift down");
	DEBUG_Print(420, 200, "Press Z to");
	DEBUG_Print(420, 350, "Use D-Pad to");
	if(edit)
	{
		DEBUG_Print(420, 220, "save value");
		DEBUG_Print(420, 370, "change value");
		DEBUG_Print(516, 390, "=  +1");
		DEBUG_Print(516, 410, "=  -1");
		DEBUG_Print(516, 430, "= +10");
		DEBUG_Print(516, 450, "= -10");
	}
	else
	{
		DEBUG_Print(420, 220, "edit value");
		DEBUG_Print(420, 370, "select value");
	}
	switch(eth_inb(0x30))
	{
		case 0x83: DEBUG_Print(0, 170, "at 100 Mbps, full duplex"); break;
		case 0x82: DEBUG_Print(0, 170, "at 100 Mbps, half duplex"); break;
		case 0x81: DEBUG_Print(0, 170, "at 10 Mbps, full duplex"); break;
		default: DEBUG_Print(0, 170, "at 10 Mbps, half duplex");
	}
	int i = 0;
	for(; i < height; i++)
	{
		DEBUG_ShowValueU8(16, 200 + i * 20, (char)((offset + i * width) / 256));
		DEBUG_ShowValueU8(48, 200 + i * 20, (char)((offset + i * width) % 256));
	}
	DEBUG_InitText(fb, COLOR_LIME);
	DEBUG_PrintChar(112, 40, 'A');
	DEBUG_InitText(fb, COLOR_RED);
	DEBUG_PrintChar(112, 60, 'B');
	DEBUG_InitText(fb, COLOR_SILVER);
	DEBUG_PrintChar(112, 80, 'X');
	DEBUG_PrintChar(112, 100, 'Y');
	DEBUG_Print(96, 120, "Start");
	DEBUG_PrintChar(532, 250, 'L');
	DEBUG_PrintChar(532, 300, 'R');
	DEBUG_Print(484, 350, "D-Pad");
	if(edit)
	{
		DEBUG_Print(420, 390, "Up");
		DEBUG_Print(420, 410, "Down");
		DEBUG_Print(420, 430, "Right");
		DEBUG_Print(420, 450, "Left");
	}
	DEBUG_InitText(fb, COLOR_FUCHSIA);
	DEBUG_PrintChar(532, 200, 'Z');
	for(i = 0; i < width * height; i++)
	{
		char value = eth_inb(i + offset);
		if(i + offset == active)
		{
			if(edit)
			{
				DEBUG_InitText(fb, value == buffer[active] ? COLOR_SILVER : COLOR_WHITE);
				value = buffer[active];
			}
			else DEBUG_InitText(fb, value == buffer[active] ? COLOR_SKYBLUE : COLOR_AQUA);
		}
		else DEBUG_InitText(fb, value == buffer[i + offset] ? COLOR_MONEYGREEN : COLOR_YELLOW);
		DEBUG_ShowValueU8(i % width * 40 + 100, 200 + i / width * 20, value);
	}
}

int main()
{
	int x = 0;
	int offset = 0;
	int width = 8;
	int height = 14;
	int count1 = 0;
	int count2 = 0;
	int count3 = 0;
	int time1 = 90;
	int time2 = 5;
	int time3 = 15;
	bool edit = 0;
	char buffer[256];
	int i = 0;
	for(; i < 256; i++) buffer[i] = eth_inb(i);
    u32 *fb = (u32*)0xc0500000;   
	VIDEO_Init(VIDEO_640X480_NTSC_YUV16);
	VIDEO_SetFrameBuffer(VIDEO_FRAMEBUFFER_BOTH, (u32)fb);
	status(offset, width, height, x, edit, buffer);
	while(1)
	{
		PAD_ReadState(&Pad, PAD_CHANNEL_0);
		if(Pad.Digital.Start)
		{
			asm("lis 3, 0x8000");
			asm("ori 3, 3, 0x1800");
			asm("mtlr 3");
			asm("blrl");
		}
		if(Pad.Digital.A && count1 % time1 == 0)
		{
			gc_init(); 
			eth_outb(0x30, 0x83);
			for(; i < 256; i++) buffer[i] = eth_inb(i);
			count1 = 0;
		}
		else if(Pad.Digital.B && count1 % time1 == 0)
		{
			gc_init(); 
			eth_outb(0x30, 0x82);
			for(; i < 256; i++) buffer[i] = eth_inb(i);
			count1 = 0;
		}
		else if(Pad.Digital.X && count1 % time1 == 0)
		{
			gc_init(); 
			eth_outb(0x30, 0x81);
			for(; i < 256; i++) buffer[i] = eth_inb(i);
			count1 = 0;
		}
		else if(Pad.Digital.Y && count1 % time1 == 0)
		{
			gc_init(); 
			eth_outb(0x30, 0x84);
			for(; i < 256; i++) buffer[i] = eth_inb(i);
			count1 = 0;
		}
		else if(Pad.Digital.L && count2 % time2 == 0)
		{
			offset -= width;
			if(offset < 0) offset = 0;
			count2 = 0;
		}
		else if(Pad.Digital.R && count2 % time2 == 0)
		{
			offset += width;
			if(offset > 256 - height * width) offset = 256 - height * width;
			count2 = 0;
		}
		else if(Pad.Digital.Z && count3 % time3 == 0)
		{
			edit = !edit;
			if(!edit) 
			{
				char value = buffer[x];
				for(i = 0; i < 256; i++) buffer[i] = eth_inb(i);
				eth_outb(x, value);
			}
			count3 = 0;
		}
		else if(Pad.Digital.Up && count2 % time2 == 0)
		{

			if(edit) buffer[x]++;
			else
			{
				if(x - width >= 0) x -= width;
				if(x < offset) offset = x / width * width;
			}
			count2 = 0;
		}
		else if(Pad.Digital.Down && count2 % time2 == 0)
		{
			if(edit) buffer[x]--;
			else
			{
				if(x + width <= 255) x += width;
				if(x >= offset + width * (height - 1)) offset = x / width * width - width * (height - 1);
			}
			count2 = 0;
		}
		else if(Pad.Digital.Left && count2 % time2 == 0)
		{
			if(edit) buffer[x] -= 0x10;
			else if(x > 0)
			{
				x--;
				if(x < offset) offset = x / width * width;
			}
			count2 = 0;
		}
		else if(Pad.Digital.Right && count2 % time2 == 0)
		{
			if(edit) buffer[x] += 0x10;
			else if(x < 255)
			{
				x++;
				if(x >= offset + width * (height - 1)) offset = x / width * width - width * (height - 1);
			}
			count2 = 0;
		}
		if(++count1 > time1) count1 = time1;
		if(++count2 > time2) count2 = time2;
		if(++count3 > time3) count3 = time3;
		status(offset, width, height, x, edit, buffer);
		VIDEO_WaitVSync();
	}
	return 0;
}
